Index: /trunk/packages/vizservers/vtkvis/RpVtkRenderer.h
===================================================================
--- /trunk/packages/vizservers/vtkvis/RpVtkRenderer.h	(revision 2422)
+++ /trunk/packages/vizservers/vtkvis/RpVtkRenderer.h	(revision 2423)
@@ -12,5 +12,5 @@
 #include <vtkCubeAxesActor.h>
 #ifdef USE_CUSTOM_AXES
-#include <vtkRpCubeAxesActor2D.h>
+#include "vtkRpCubeAxesActor2D.h"
 #else
 #include <vtkCubeAxesActor2D.h>
@@ -59,4 +59,10 @@
         Y_AXIS,
         Z_AXIS
+    };
+
+    enum PrincipalPlane {
+        PLANE_XY,
+        PLANE_ZY,
+        PLANE_XZ
     };
 
@@ -104,4 +110,6 @@
     DataSet *getDataSet(const DataSetId& id);
 
+    void getDataSetNames(std::vector<std::string>& names);
+
     bool setData(const DataSetId& id, char *data, int nbytes);
 
@@ -112,7 +120,11 @@
     bool setDataSetActiveVectors(const DataSetId& id, const char *vectorName);
 
-    double getDataValueAtPixel(const DataSetId& id, int x, int y);
-
-    double getDataValue(const DataSetId& id, double x, double y, double z);
+    bool getScalarValueAtPixel(const DataSetId& id, int x, int y, double *value);
+
+    bool getScalarValue(const DataSetId& id, double x, double y, double z, double *value);
+
+    bool getVectorValueAtPixel(const DataSetId& id, int x, int y, double vector[3]);
+
+    bool getVectorValue(const DataSetId& id, double x, double y, double z, double vector[3]);
 
     void setOpacity(const DataSetId& id, double opacity);
@@ -148,4 +160,6 @@
     void resetCameraClippingRange();
 
+    void setCameraZoomRegionPixels(int x, int y, int width, int height);
+
     void setCameraZoomRegion(double x, double y, double width, double height);
 
@@ -232,7 +246,7 @@
     // 2D Contour plots
 
-    void addContour2D(const DataSetId& id, int numContours);
-
-    void addContour2D(const DataSetId& id, const std::vector<double>& contours);
+    bool addContour2D(const DataSetId& id, int numContours);
+
+    bool addContour2D(const DataSetId& id, const std::vector<double>& contours);
 
     void deleteContour2D(const DataSetId& id);
@@ -266,7 +280,7 @@
     // 3D Contour (isosurface) plots
 
-    void addContour3D(const DataSetId& id, int numContours);
-
-    void addContour3D(const DataSetId& id, const std::vector<double>& contours);
+    bool addContour3D(const DataSetId& id, int numContours);
+
+    bool addContour3D(const DataSetId& id, const std::vector<double>& contours);
 
     void deleteContour3D(const DataSetId& id);
@@ -308,5 +322,5 @@
     // Glyphs
 
-    void addGlyphs(const DataSetId& id, Glyphs::GlyphShape shape);
+    bool addGlyphs(const DataSetId& id, Glyphs::GlyphShape shape);
 
     void deleteGlyphs(const DataSetId& id);
@@ -352,7 +366,7 @@
     // Height maps
 
-    void addHeightMap(const DataSetId& id, int numContours);
-
-    void addHeightMap(const DataSetId& id, const std::vector<double>& contours);
+    bool addHeightMap(const DataSetId& id, int numContours, double heightScale);
+
+    bool addHeightMap(const DataSetId& id, const std::vector<double>& contours, double heightScale);
 
     void deleteHeightMap(const DataSetId& id);
@@ -382,4 +396,6 @@
     void setHeightMapVisibility(const DataSetId& id, bool state);
 
+    void setHeightMapWireframe(const DataSetId& id, bool state);
+
     void setHeightMapVolumeSlice(const DataSetId& id, HeightMap::Axis axis, double ratio);
 
@@ -388,9 +404,11 @@
     void setHeightMapColorMap(const DataSetId& id, const ColorMapId& colorMapId);
 
-    void setHeightMapContours(const DataSetId& id, int numContours);
+    void setHeightMapNumContours(const DataSetId& id, int numContours);
 
     void setHeightMapContourList(const DataSetId& id, const std::vector<double>& contours);
 
-    void setHeightMapContourVisibility(const DataSetId& id, bool state);
+    void setHeightMapContourSurfaceVisibility(const DataSetId& id, bool state);
+
+    void setHeightMapContourLineVisibility(const DataSetId& id, bool state);
 
     void setHeightMapContourEdgeColor(const DataSetId& id, float color[3]);
@@ -400,5 +418,5 @@
     // LIC plots
 
-    void addLIC(const DataSetId& id);
+    bool addLIC(const DataSetId& id);
     
     void deleteLIC(const DataSetId& id);
@@ -434,5 +452,5 @@
     // Molecules
 
-    void addMolecule(const DataSetId& id);
+    bool addMolecule(const DataSetId& id);
     
     void deleteMolecule(const DataSetId& id);
@@ -474,5 +492,5 @@
     // PolyData Meshes
 
-    void addPolyData(const DataSetId& id);
+    bool addPolyData(const DataSetId& id);
     
     void deletePolyData(const DataSetId& id);
@@ -498,4 +516,6 @@
     void setPolyDataEdgeWidth(const DataSetId& id, float edgeWidth);
 
+    void setPolyDataPointSize(const DataSetId& id, float size);
+
     void setPolyDataLighting(const DataSetId& id, bool state);
 
@@ -509,5 +529,5 @@
     // Color-mapped surfaces
 
-    void addPseudoColor(const DataSetId& id);
+    bool addPseudoColor(const DataSetId& id);
 
     void deletePseudoColor(const DataSetId& id);
@@ -543,5 +563,5 @@
     // Streamlines
 
-    void addStreamlines(const DataSetId& id);
+    bool addStreamlines(const DataSetId& id);
 
     void deleteStreamlines(const DataSetId& id);
@@ -612,5 +632,5 @@
     // Volumes
 
-    void addVolume(const DataSetId& id);
+    bool addVolume(const DataSetId& id);
 
     void deleteVolume(const DataSetId& id);
@@ -678,4 +698,7 @@
     void computeScreenWorldCoords();
 
+    bool is2D(const double bounds[6],
+              PrincipalPlane *plane,
+              double *offset) const;
     void initCamera();
     void initAxes();
@@ -687,4 +710,6 @@
     double _imgWorldOrigin[2];
     double _imgWorldDims[2];
+    PrincipalPlane _imgCameraPlane;
+    double _imgCameraOffset;
     double _screenWorldCoords[4];
     double _cameraOrientation[4];
